--Rings original by unknown
--Stuff rewritten and modified by NepDisk, Indev and Callmore
--Further Revision for Lore-Accurate Super Forms by RetroStation

freeslot("SPR_RNGS", "S_RINGSO", "MT_RINGGET")


rawset(_G, "rings", {
	grabsound = sfx_s227,
	usesound = sfx_s1ce,
	spillsound = sfx_s1c6,
	stingsound = sfx_s1a6,
	customrgsprite = nil,
	ringcap = 20,
	ringusecap = 15,
})

local function getRingstuff(p)
	if not p.ringstuff then
		p.ringstuff = {}
	end

	return p.ringstuff
end

states[S_RINGSO] = {SPR_RNGS, FF_ANIMATE, -1, nil, 23, 2, S_RINGSO}

mobjinfo[MT_RINGGET] = {
	doomednum = -1,
	spawnstate = S_RINGSO,
	spawnhealth = 1000,
	radius = 19*FRACUNIT,
	height = 40*FRACUNIT,
	flags = MF_DONTENCOREMAP|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY
}

local hudoppfontsprites = nil
local function drawRingHud(v, p)
	--Checks
	if not (p.masteremerald and p.masteremerald.super) return end
	if (nuvote and get_nv_state() ~= NV_DEFAULT) then return end
	if not (p.mo and p.mo.valid) then return end

	local rs = getRingstuff(p)
	
	-- cache Font Sprites
	if hudoppfontsprites == nil then
		hudoppfontsprites = {}
		for i = 0, 9 do 
			hudoppfontsprites[i] = v.cachePatch("OPPRNK0" ..i)
		end
	end
	
	if leveltime < TICRATE then return end

	local plrRings
	if rs.numRings ~= nil then
		plrRings = rs.numRings
	else
		plrRings = 0
	end
	
	
	local basex = 45
	local basey = 80
	local flags = V_HUDTRANS
	--Splitscreen code	
	if splitscreen <= 1 then
		basex = $ * 2
		flags = $|V_SNAPTOLEFT
		if splitscreen == 0 then
			basey = $ * 2
			flags = $|V_SNAPTOBOTTOM
		else
			basey = $ + (p.splitscreenindex * 100) - 16
			flags = $|(p.splitscreenindex * V_SNAPTOBOTTOM)
		end
	elseif splitscreen >= 2 then
		basex = 45
		basey = 83
		if p.splitscreenindex % 2 == 1 then	//Right Side of Screen
			basex = 320 - basex - 24
			flags = $|V_SNAPTORIGHT
		else //Left Side of Screen
			flags = $|V_SNAPTOLEFT
		end
		
		basey = $ + ((p.splitscreenindex / 2) * 100) - 12 - 1
		flags = $|((p.splitscreenindex / 2)*V_SNAPTOBOTTOM)
	end
	
	--cache patches needed for drawing
	local ringHud = v.cachePatch("SRINGBG")
	local hudBGX = -1
	
	--Actually draw the hud
	v.draw(basex + hudBGX, basey, ringHud, flags)
	local SRing = v.cachePatch("SRING1")
	v.draw(basex, basey + 2, SRing, flags)
	
	-- Turn Player Number into a table of num patches
	local s = string.format("%02d",tostring(abs(plrRings)))
	local nums = {}
	local font = hudoppfontsprites
	s:gsub(".", function(c) table.insert(nums, font[tonumber(c)]) end)
	-- Iterate through Table and print digits of numbers
	-- Print them from right to left to get digits right-aligned
	for i = #nums, 1, -1 do
		if nums[i] == nil then continue end
		local digoffset = (#nums - (i - 1)) * 6
		local x = basex+20-digoffset
		local y = basey+17
		v.draw(x, y, nums[i], flags)
	end
end

local function RS_Init(p)
	local rs = getRingstuff(p)

	rs.numRings = 0
	rs.ringsToAward = 0
	rs.activeAwardRings = 0
	rs.awardTimer = 0
end
addHook("PlayerSpawn", RS_Init)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid and mo.player) then return end
	local p = mo.player
	local rs = getRingstuff(p)

	if (p.masteremerald and p.masteremerald.super) then
		rs.numRings = max($, 0)
		
		p.ringslasttrick = $ or 0
		if acrobasics then
			if ((not p.hastricked) and p.ringslasttrick) then
				local amount = 4
				if p.kartstuff[k_position] == 1 then
					amount = 1
				elseif p.kartstuff[k_position] > 1
				and not K_IsPlayerLosing(p) then
					amount = 2
				end
				doRingAward(p, amount*p.trickgrade, true)
			end
		end

		if (rs.ringsToAward ~= nil)
			if (rs.ringsToAward > 0)
				rs.awardTimer = $ + 1
				local interval = 2

				if ((rs.awardTimer % interval) == 0)
					local mos = mapobjectscale
					local awardRing = P_SpawnMobj(mo.x, mo.y, mo.z+(24*mos), MT_RINGGET)
					awardRing.target = p.mo
					if (p.xirings and p.xirings.jackpot == true) then
						awardRing.jackpot = true
					end
					rs.ringsToAward = $ - 1
					rs.activeAwardRings = rs.activeAwardRings + 1
				end
			elseif (rs.awardTimer > 0)
				rs.awardTimer = 0
				if (p.xirings and p.xirings.jackpot == true) then
					p.xirings.jackpot = false
				end
			end
		end

		p.ringslasttrick = p.hastricked
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	local mos = mapobjectscale
	
	if (mo.distFromTarget == nil)
		mo.distFromTarget = 42*mos
		mo.angOffset = 0
		mo.subtractOffset = 0
		mo.actualDist = (((mo.distFromTarget)*mos)/10000)
	else
		local subval = ((mos*30)/11)
		local scalesub = ((mos/2)/11)
		if (mo.distFromTarget > (16*mos))
			mo.distFromTarget = ($1 - subval)
			mo.scale = ($1 - scalesub)
		end
		local tgDist = mo.distFromTarget
		mo.angOffset = $1 + 28
		if (mo.target ~= nil)
			local targ = mo.target
			local xdist = (tgDist/mos)*FixedMul(cos(targ.angle+(mo.angOffset*ANG1)), mos)
			local ydist = (tgDist/mos)*FixedMul(sin(targ.angle+(mo.angOffset*ANG1)), mos)
			P_MoveOrigin(mo,targ.x+(xdist),targ.y+(ydist),targ.z+(tgDist))
			xdist = nil
			ydist = nil
		end
		if (mo.distFromTarget <= (16*mos))
			local p = ((mo.target) and mo.target.player or nil)

			if (not p) then P_RemoveMobj(mo) return end

			local rs = getRingstuff(p)

			
			rs.numRings = $ + 1

			S_StartSound(mo.target, rings.grabsound)

			rs.activeAwardRings = rs.activeAwardRings - 1
			p = nil
			P_RemoveMobj(mo)
		end
	end
end, MT_RINGGET)

-- Gets the total amount of rings a player holds including rings that are currently still being added.
rawset(_G, "getTotalRings", function (p)
	local rs = getRingstuff(p)

	return rs.numRings + rs.ringsToAward + rs.activeAwardRings
end)

rawset(_G, "doRingAward", function(p, amt,disp)
	local rs = getRingstuff(p)

	if amt <= 0 then return end

	rs.ringsToAward = rs.ringsToAward + amt
end)

addHook("PlayerSpawn", function(p)
	local rs = getRingstuff(p)

	rs.ringsToAward = 0 -- reset the rings you're getting
	rs.activeAwardRings = 0
end)

local function setRingSounds(mapnum)
	-- why can't S_sfx use freeslots, WHY
	rings.grabsound = sfx_s227
	rings.usesound = sfx_s1ce
	rings.spillsound = sfx_s1c6
	rings.stingsound = sfx_s1a6
	rings.customrgsprite = nil
	
	local soundsmax = ((#S_sfx)-1)
	local spritesmax = (#sprnames)-1
	local spritelog
	
	for i = 0, spritesmax
		if (sprnames[i] == socSprString)
			spritelog = i // log the ID
			break
		end
	end
	
	if (spritelog)
		for i = 0, (#states - 1)
			if (states[i].sprite == spritelog)
				rings.customrgsprite = i
				print("found state")
				break
			end
		end
	end
end

addHook("MapLoad", function()
	--SOC-based adjustment
	setRingSounds(tonumber(gamemap))
		
	for p in players.iterate do
		local rs = getRingstuff(p)

		rs.numRings = 10
		rs.stingAlertMobj = nil
	end
end)

addHook("NetVars", function(n)
	rings = n($) // netvar for custom sprites and such
end)

rawset(_G, "awardRingsFromObject", function(p, mo, disp)
	local awardamount = 10

	if p.kartstuff[k_position] == 1 then
		awardamount = 3
	elseif not K_IsPlayerLosing(p) then
		awardamount = 5
	end
	doRingAward(p, awardamount, disp)
end)

addHook("PlayerThink", function(p)
	if not (p.masteremerald and p.masteremerald.super) return end
	if not p.mo then return end
    
    if p.kartstuff[k_itemroulette]
	and not p.lastitemroulette
	and p.kartstuff[k_roulettetype] ~= 2 then
         awardRingsFromObject(p, p.mo, 1)
    end
    
	local rs = getRingstuff(p)

    p.lastitemroulette = p.kartstuff[k_itemroulette]
end)
hud.add(drawRingHud)