--Because I love chaos.

local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
--local MAXSKINCOLORS = MAXSKINCOLORS
--local ANG1 = ANG1
--local k_sneakertimer = k_sneakertimer
--local k_spinouttimer = k_spinouttimer
--local k_wipeoutslow = k_wipeoutslow
--local k_driftboost = k_driftboost
--local k_floorboost = k_floorboost
--local k_startboost = k_startboost
local k_itemamount = k_itemamount
--local k_itemtype = k_itemtype
--local k_rocketsneakertimer = k_rocketsneakertimer
--local k_hyudorotimer = k_hyudorotimer
--local k_drift = k_drift
--local k_speedboost = k_speedboost
--local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
--local k_growshrinktimer = k_growshrinktimer
--local k_throwdir = k_throwdir

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon and dropped item frame changes depending on the item amount (animation frames become amount frames)
local XIF_SMUGGLECHECK = 128 --item contributes to the smuggle detection


local cv_invincibility = CV_RegisterVar({
    name = "sf_invincibility",
    defaultvalue = "On",
    flags = CV_NETVAR|CV_CALL,
    PossibleValue = CV_OnOff,
	func = function(var)
		if var.value then
			xItemLib.func.setGlobalOddsForItem(xItemLib.xItemNamespaces["KITEM_INVINCIBILITY"],
	{0, 0, 0, 0, 0, 1, 4, 6, 10, 0}, nil)
		else
			xItemLib.func.setGlobalOddsForItem(xItemLib.xItemNamespaces["KITEM_INVINCIBILITY"],
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 0}, nil)
		end
	end
})

local function cSpd(ang, spd, mo)
	if mo == nil then mo = {scale=FRACUNIT} end
	spd = FixedMul(spd, mo.scale)
	return FixedMul( cos(ang), spd ), FixedMul( sin(ang), spd )
	--returns x and y of calc
end

local function EM_Orbiter(actor)
	if not (actor and actor.valid) then return end
	local emeralds = {sprite = {{SPR_OREM, 4}}, count = 7, scale = {FRACUNIT}, colors = {SKINCOLOR_GREEN,SKINCOLOR_RED,
																				   SKINCOLOR_CYAN,SKINCOLOR_WHITE,
																				   SKINCOLOR_PURPLE,SKINCOLOR_BLUE,
																				   SKINCOLOR_YELLOW}}
	if MasterEmerald.Transformations[actor.skin] and MasterEmerald.Transformations[actor.skin].emeralds then
		emeralds.sprite = MasterEmerald.Transformations[actor.skin].emeralds.sprite or $
		emeralds.count = MasterEmerald.Transformations[actor.skin].emeralds.count or $
		emeralds.scale = MasterEmerald.Transformations[actor.skin].emeralds.scale or $
		emeralds.colors = MasterEmerald.Transformations[actor.skin].emeralds.colors or $
	end
	
	if not (actor.EMorbit and actor.EMorbit.valid) then
		for i = 1, emeralds.count do
			local e = P_SpawnMobj(actor.x, actor.y, actor.z + actor.height/2, MT_EMERALDORBIT)
			e.sprite = emeralds.sprite[(i % #emeralds.sprite)+1][1]
			e.emframes = emeralds.sprite[(i % #emeralds.sprite)+1][2]
			e.scale = FixedMul(3*actor.scale/2, emeralds.scale[(i % #emeralds.scale)+1])
			e.fuse = 35
			e.target = actor
			--e.colorized = true
			e.color = emeralds.colors[(i % #emeralds.colors)+1]
			e.angmod = (360/emeralds.count)*ANG1 * i
			e.EMnumber = i
			if i == 1 then
				actor.EMorbit = e
			end
		end
	end
end

local function EM_OrbitThinker(mo)
	if mo.EMactive == nil then mo.EMactive = 0 end
	
	mo.EMactive = $+1
	
	if (mo and mo.valid) and mo.EMactive > 1 then
		if mo.target and mo.target.valid and mo.target.EMorbit then
			mo.frame = ((leveltime/3)%(mo.emframes))|FF_FULLBRIGHT
			if mo.fuse <= 10 then
				if (leveltime & 1)
					mo.flags2 = $ | MF2_DONTDRAW
				else
					mo.flags2 = $ & ~MF2_DONTDRAW
				end
			end

			local t = mo.target
			local offset = t.height/2
			local thisAng = leveltime*(ANG2*3)
			local x,y = cSpd(thisAng+mo.angmod, (abs(mo.fuse - 36)*2)*mapobjectscale, t)
			P_MoveOrigin(mo, t.x+x, t.y+y, t.z + offset + ((3*abs(mo.fuse - 36)/2)*mapobjectscale))
		else
			P_RemoveMobj(mo)
			return
		end
	end
	
	local pmo = mo.target
	local p = mo.target.player
	if pmo and pmo.valid and p then
		if mo.fuse == 1
		and pmo.EMorbit == mo then
			if (HugeQuest and p.hugequest.huge > 0) then
				p.hugequest.huge = 1
			end

			p.ringstuff.numRings = 50
			p.masteremerald.super = 1
			S_ChangeMusic("emsupr",true, p)
			K_PlayPowerGloatSound(pmo)
		end
	end
end
addHook("MobjThinker", EM_OrbitThinker, MT_EMERALDORBIT)

local function EM_BeamThinker(mo)
	if not (mo and mo.valid) then return end
	
	if mo.target and mo.target.valid then
		local newx = mo.target.x + P_ReturnThrustX(mo, mo.target.angle, FixedMul(-mo.target.radius*2, mo.target.scale))
		local newy = mo.target.y + P_ReturnThrustY(mo, mo.target.angle, FixedMul(-mo.target.radius*2, mo.target.scale))
		P_MoveOrigin(mo, newx, newy, mo.target.z)
	end
end
addHook("MobjThinker", EM_BeamThinker, MT_XEMBEAM)

local function GetSuper(p,i)
	S_StartSound(p.mo, sfx_cgot, p)
			
	if chaosdrives
	and (CV_FindVar("cd_mode").value ~= 3
	and CV_FindVar("cd_mode").value ~= 0) then -- Because theming
		p.cd_run = min ($ + (FixedRound(chaosdrives.max*FRACUNIT/5)/FRACUNIT), chaosdrives.max)
		p.cd_swim = min ($ + (FixedRound(chaosdrives.max*FRACUNIT/5)/FRACUNIT), chaosdrives.max)
		p.cd_fly = min ($ + (FixedRound(chaosdrives.max*FRACUNIT/5)/FRACUNIT), chaosdrives.max)
		p.cd_power = min ($ + (FixedRound(chaosdrives.max*FRACUNIT/5)/FRACUNIT), chaosdrives.max)		
	end
end

local function UseSuper(p,cmd)
	local pks = p.kartstuff
	if p.masteremerald.super then
		if p.hugequest and p.hugequest.sparkle then
			p.hugequest.sparkle = 0
		end
		K_PlayPowerGloatSound(p.mo)
	else
		EM_Orbiter(p.mo)
		if p.hugequest then
			p.hugequest.sparkle = 0
		end
		pks[k_invincibilitytimer] = TICRATE
	end

	pks[k_itemamount] = $-1
	
	--masteremeraldcd = 20*TICRATE -- No consecutive Emerald pulls, maybe
end

if xItemLib then
	xItemLib.func.addItem{"XITEM_SUPERFORM", 
		"Super Form", 
		{3, "K_ITEMR1", "K_ITEMR2", "K_ITEMR3", "K_ITEMR4"}, 
		{3, "K_ISEMR1", "K_ISEMR2", "K_ISEMR3", "K_ISEMR4"},
		XIF_POWERITEM|XIF_COOLDOWNONSTART|XIF_SMUGGLECHECK,
		{ 0, 0, 0, 0, 0, 0, 2, 3, 4, 0 },
		{ 1, 2},
		GetSuper,
		UseSuper,
		nil,
		nil,
		nil,
		{3, {SPR_XEMR, A},{SPR_XEMR, B},{SPR_XEMR, C},{SPR_XEMR, D},{SPR_XEMR, C},{SPR_XEMR, B}},
		true,
		nil,
		nil
	}
end